明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 18306|回复: 13

如何获取CAD多段线各顶点坐标

  [复制链接]
发表于 2007-10-28 18:00:00 | 显示全部楼层 |阅读模式
如何获取CAD各顶点坐标呢?
本人一直在试,一直未获成功,心情异常沉重,肯请各位老兄给予指点!!

发表于 2008-3-19 09:17:00 | 显示全部楼层

论坛上有这个方面的资料,建议查询一下

发表于 2008-3-19 20:52:00 | 显示全部楼层
本帖最后由 作者 于 2008-3-19 20:53:25 编辑

给你个可输出polygon多段线节点的小程序(适用于AutoCAD 2004)

本帖子中包含更多资源

您需要 登录 才可以下载或查看,没有账号?注册

x
发表于 2008-3-20 14:25:00 | 显示全部楼层

语法

object.Coordinate(index)

object

3DPoly, Leader, LightweightPolyline, PolyfaceMesh, PolygonMesh, Polyline, Solid, Trace
使用该属性的对象。

Coordinate

Variant[变体] (三元素或两元素双精度数组); 可读写
指定顶点的 X、 Y 和 Z 坐标的数组。

LightweightPolyline 对象:变体为两元素,它表示 OCS 坐标系统下的 X 和 Y 坐标。
Polyline 对象:: 变体为三元素,它表示 OCS 坐标系统下的 X 和 Y 坐标。而 Z 坐标在变体中有预留但被忽略。

所有其它对象:变体为三元素,它表示 WCS 坐标系统下的 X 和 Y 坐标;而 Z 坐标在活动 UCS 上默认为 0。

Index

Integer[整数]
在顶点数组中你所要设置或查询的顶点的索引号。顶点数组的基数为 0。

说明

该属性将替换指定对象任何存在的顶点。使用标准的数组处理技术来处理包含在该属性中的值。

3DPolyline, Polyline, PolygonMesh: 对于简单的多段线 (非样条化或曲线拟合),该属性指的是一般的顶点。对于样条化或曲线拟合的多段线,该属性指的是控制点顶点。

Polyline 和 LightweightPolyline 对象的 OCS 坐标可以使用 TranslateCoordinates 方法与其它坐标系统进行转换。

明经通道 ©2000-2006 版权所有 不得复制传播 
该拷贝仅用于明经通道网站在线服务使用,如需要购买,请联系本站管理员:mccad,邮件地址:mccad@mjtd.com

Sub Example_Coordinate()
    ' This example creates a polyline in model space and
    ' queries and changes the coordinate in the first index position.
        
    Dim plineObj As AcadPolyline
    Dim points(0 To 14) As Double
    
    ' Define the 2D polyline points
    points(0) = 1: points(1) = 1: points(2) = 0
    points(3) = 1: points(4) = 2: points(5) = 0
    points(6) = 2: points(7) = 2: points(8) = 0
    points(9) = 3: points(10) = 2: points(11) = 0
    points(12) = 4: points(13) = 4: points(14) = 0
        
    ' Create a lightweight Polyline object in model space
    Set plineObj = ThisDrawing.ModelSpace.AddPolyline(points)
    ZoomAll
    
    ' Find the coordinate in the first index position
    Dim coord As Variant
    coord = plineObj.Coordinate(0)
    MsgBox "The coordinate in the first index position of the polyline is: " & coord(0) & ", " _
        & coord(1) & ", " & coord(2)
    
    ' Change the coordinate
    coord(0) = coord(0) + 1
    plineObj.Coordinate(0) = coord
    plineObj.Update
    
    ' Query the new coordinate
    coord = plineObj.Coordinate(0)
    MsgBox "The coordinate in the first index position of the polyline is now: " & coord(0) & ", " _
        & coord(1) & ", " & coord(2)
    
End Sub

发表于 2008-3-20 14:27:00 | 显示全部楼层

明经中文通道里搜Coordinate

http://www.mjtd.com/object/acad2004/

发表于 2010-4-29 19:55:00 | 显示全部楼层
谢谢啊
发表于 2010-5-1 16:56:00 | 显示全部楼层

一定要注意这两种多段线的定义.

  Dim pl As AcadPolyline
  Dim ppl As AcadLWPolyline


发表于 2010-7-6 12:36:00 | 显示全部楼层
谢谢哈!
发表于 2010-8-30 08:08:00 | 显示全部楼层
这个有实用价值。下来学习了。
发表于 2010-9-19 17:34:00 | 显示全部楼层

多谢了,正需要这样的东西。

您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 10:51 , Processed in 0.180231 second(s), 25 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表